(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  this.PuppetEnterpriseConsole = (function(_super) {
    var _this = this;

    __extends(PuppetEnterpriseConsole, _super);

    function PuppetEnterpriseConsole() {
      return PuppetEnterpriseConsole.__super__.constructor.apply(this, arguments);
    }

    PuppetEnterpriseConsole.set('isReady', false);

    PuppetEnterpriseConsole.on('ready', function() {
      PuppetEnterpriseConsole.set('isReady', true);
      PuppetEnterpriseConsole.Node.observeAndFire('filtered', PuppetEnterpriseConsole.adjustNodeListHeight);
      Timer.start();
      $('abbr').live({
        mouseenter: function() {
          $(this).tooltip({
            delay: 100,
            selector: '[rel=tooltip]',
            placement: 'bottom'
          });
          return $(this).tooltip('show');
        },
        mouseleave: function() {
          return $(this).tooltip('hide');
        }
      });
      return $.ajax({
        url: '/console/services/certificates/api/v1/csr_count',
        success: function(response) {
          return $('.node-requests-link').text('node requests (' + response.request_count + ')');
        }
      });
    });

    PuppetEnterpriseConsole.observe('currentRoute', function(route) {
      var _ref;
      if ((_ref = route.controller) !== 'resources' && _ref !== 'cloning') {
        return PuppetEnterpriseConsole.get('dispatcher.controllers.cloning').cancelCloning();
      }
    });

    PuppetEnterpriseConsole.route('cloning', 'cloning#preview');

    PuppetEnterpriseConsole.route('resources', 'resources#index');

    PuppetEnterpriseConsole.route('resources/:id', 'resources#show', {
      resource: 'resource_types',
      action: 'show',
      as: 'show_resource'
    });

    PuppetEnterpriseConsole.route('resources/:type/:title', 'resources#details', {
      as: 'show_resource_detail'
    });

    PuppetEnterpriseConsole.route('orchestration', 'orchestration#index');

    PuppetEnterpriseConsole.route('orchestration/:id', 'orchestration#show', {
      resource: 'agents',
      action: 'show',
      as: 'show_agent'
    });

    PuppetEnterpriseConsole.route('puppetd', 'puppetd#show');

    PuppetEnterpriseConsole.root('resources#index', {
      as: 'resource_summary'
    });

    PuppetEnterpriseConsole.adjustNodeListHeight = function() {
      var nodeSelector, selectorTop;
      if (!(nodeSelector = $('#node-selector')).length) {
        return setTimeout(arguments.callee, 50);
      }
      selectorTop = nodeSelector.position().top + nodeSelector.outerHeight(true);
      if (!(selectorTop > 150)) {
        return setTimeout(arguments.callee, 50);
      }
      return $('.master-node-list').css({
        top: selectorTop
      });
    };

    PuppetEnterpriseConsole.toggleAdvancedSearch = function(node) {
      var $node;
      $(node).toggleClass('expanded');
      $node = $('.search .advanced');
      return $node.animate({
        height: $node.is(':visible') ? 'hide' : 'show'
      }, {
        duration: 200,
        step: this.adjustNodeListHeight,
        complete: this.adjustNodeListHeight
      });
    };

    PuppetEnterpriseConsole.toggleNodeList = function(node) {
      $(node).parents('.expander-parent').find('.node-expander .expandable').toggleClass('expanded');
      return $(node).parents('.expander-parent').find('.node-list').animate({
        height: 'toggle',
        width: 'toggle'
      }, 100);
    };

    PuppetEnterpriseConsole.expandAgentResults = function(node) {
      var parent_table;
      parent_table = $(node).parents('.agent-output')[0];
      $(parent_table).find('.agent-summary').toggleClass('inactive');
      $(parent_table).find('.agent-result').toggleClass('inactive');
      return $(parent_table).find('.controls').children().toggleClass('inactive');
    };

    PuppetEnterpriseConsole.reduceAgentResults = function(node) {
      var parent_table;
      parent_table = $(node).parents('.agent-output')[0];
      $(parent_table).find('.agent-summary').toggleClass('inactive');
      $(parent_table).find('.agent-result').toggleClass('inactive');
      return $(parent_table).find('.controls').children().toggleClass('inactive');
    };

    PuppetEnterpriseConsole.toggleAction = function(node) {
      var form;
      form = $(node).parents('li').find('form');
      this.closeActions(form);
      form.slideToggle('fast');
      return $(node).parents('li').toggleClass('active');
    };

    PuppetEnterpriseConsole.closeActions = function(form) {
      return form.parents('ul').find('form').not(form).parent().removeClass('active').end().slideUp('fast');
    };

    PuppetEnterpriseConsole.togglePopover = function(target, id) {
      var $popup, $target, left, top;
      $popup = $("#" + id);
      $target = $(target);
      if ($popup.is(':visible')) {
        return;
      }
      $popup.attr({
        tabindex: -1
      });
      $popup.blur(function() {
        return $popup.fadeOut(100, function() {
          return $popup.attr({
            tabindex: null
          });
        });
      });
      if ($popup.hasClass('left') || $popup.hasClass('right')) {
        top = $target.position().top + ($target.outerHeight() / 2) - ($popup.outerHeight() / 2);
        left = $target.position().left + ($popup.hasClass('left') ? -($popup.outerWidth() + 4) : $target.outerWidth() + 4);
      } else if ($popup.hasClass('above') || $popup.hasClass('below')) {
        left = $target.position().left + ($target.outerWidth() / 2) - ($popup.outerWidth() / 2);
        top = $target.position().top + ($popup.hasClass('above') ? -$popup.outerHeight() : $target.outerHeight());
      }
      if (left < 0) {
        left = void 0;
      }
      $popup.animate({
        top: top,
        left: left
      }, 0);
      if (left == null) {
        $popup.find('.arrow').css({
          left: $target.offset().left - $popup.offset().left + $target.width() / 2
        });
      }
      $popup.fadeIn(100);
      return $popup.focus();
    };

    return PuppetEnterpriseConsole;

  }).call(this, Batman.App);

  Batman.DOM.readers.prefetch = function(_, key) {
    return Batman.View.sourceCache.prefetch(Batman.Navigator.normalizePath(Batman.View.prototype.prefix, key));
  };

  Batman.RestStorage.Filtered = function(param, value) {
    return (function(_super) {

      __extends(_Class, _super);

      function _Class() {
        return _Class.__super__.constructor.apply(this, arguments);
      }

      _Class.prototype.before('read', 'readAll', function(_arg, next) {
        var options;
        options = _arg.options;
        options.data || (options.data = {});
        options.data[param] = value();
        return next();
      });

      return _Class;

    })(Batman.RestStorage);
  };

  Batman.RestStorage.Filtered.ByNodeSet = Batman.RestStorage.Filtered('nodeset_id', function() {
    return PuppetEnterpriseConsole.Node.validateAndGetNodeSetID();
  });

  Batman.Filters.ifUndefined = function(value, otherwise) {
    if (value != null) {
      return value;
    } else {
      return otherwise;
    }
  };

  Batman.Filters['if'] = function(value, truthy, falsey) {
    if (value) {
      return truthy;
    } else {
      return falsey;
    }
  };

  Batman.Filters['and'] = function(predicate, value) {
    return predicate && value;
  };

  Batman.Filters['or'] = function(predicate, value) {
    return predicate || value;
  };

  Batman.Filters.json = function(value) {
    return JSON.stringify(value);
  };

  Batman.Filters.trivial = function(value, depth) {
    var result, _i, _len;
    if ($.isArray(value)) {
      for (_i = 0, _len = value.length; _i < _len; _i++) {
        result = value[_i];
        if (Batman.Filters.summarize(result[0], depth) !== Batman.Filters.prettify(result[0], depth)) {
          return false;
        }
      }
      return true;
    }
    return Batman.Filters.summarize(value, depth) === Batman.Filters.prettify(value);
  };

  Batman.Filters.summarize = function(value, depth, binding) {
    var k, str, type, v, _i, _j, _len, _len1, _ref, _ref1;
    if (binding != null) {
      binding.escapeValue = false;
    }
    type = Batman.Filters["typeof"](value);
    if (depth === 0 && type !== "scalar" && type !== "null") {
      return '<h3><a data-event-click="expandAgentResults">...</a></h3>';
    }
    str = '';
    if (type === "null") {
      str += '<em class="undefined">&mdash;</em>';
    } else if (type === "hash") {
      str += '<table class="striped">';
      _ref = Object.keys(value).sort();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        str += "<tr><th>" + k + "</th><td>" + (Batman.Filters.summarize(value[k], depth - 1)) + "</td></tr>";
      }
      str += '</table>';
    } else if (type === "array") {
      str += '<ul>';
      _ref1 = value.sort();
      for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
        k = _ref1[_j];
        str += "<li>" + (Batman.Filters.summarize(k, depth - 1)) + "</li>";
      }
      str += '</ul>';
    } else if (type === "scalar") {
      v = value;
      if (typeof value === "string" && value.match(/\r|\n/)) {
        v = "<pre>" + value + "</pre>";
      }
      str += v;
    }
    return str;
  };

  Batman.Filters["typeof"] = function(value) {
    if (!value || (value && !!value.constructor.keys && Object.keys(value).length === 0) || (value && $.isArray(value) && value.length === 0)) {
      return "null";
    } else if (!!value.constructor.keys) {
      return "hash";
    } else if ($.isArray(value)) {
      return "array";
    } else {
      return "scalar";
    }
  };

  Batman.Filters.prettify = function(value, binding) {
    if (binding != null) {
      binding.escapeValue = false;
    }
    return Batman.Filters.summarize(value, -1);
  };

  Batman.Filters.expandArray = function(array, binding) {
    var str, value, _i, _len;
    if (binding != null) {
      binding.escapeValue = false;
    }
    str = '';
    for (_i = 0, _len = array.length; _i < _len; _i++) {
      value = array[_i];
      str += "<li>" + (Batman.Filters.prettify(value)) + "</li>";
    }
    return str;
  };

  Batman.Filters.expandHash = function(hash, binding) {
    var key, str, value;
    if (binding != null) {
      binding.escapeValue = false;
    }
    str = '';
    for (key in hash) {
      value = hash[key];
      str += "<tr>\n  <td>" + key + "</td>\n  <td>" + (Batman.Filters.prettify(value)) + "</td>\n</tr>";
    }
    return str;
  };

  Batman.Filters.allEquals = function(list, value) {
    var container;
    if (list == null) {
      return true;
    }
    container = new Batman.Hash();
    value = JSON.stringify(value);
    list.map(function(x) {
      return container.set(JSON.stringify(x) === value);
    });
    return container.keys().indexOf(false) < 0;
  };

  Batman.Filters.asPercentOf = function(fraction, total, inverse) {
    var percent;
    if (inverse == null) {
      inverse = false;
    }
    percent = 100 * fraction / total;
    if (isNaN(percent)) {
      percent = 0;
    }
    percent = inverse === true ? 100 - percent : percent;
    return percent.toFixed(1) + '%';
  };

  Batman.Filters.deepEquals = function(a, b) {
    return JSON.stringify(a) === JSON.stringify(b);
  };

  Batman.Filters.slice = function(list, start, end) {
    if (list == null) {
      return;
    }
    if (list.toArray) {
      list = list.toArray();
    }
    return list.slice(start, end);
  };

  Batman.Filters.curry = function() {
    var f, params;
    f = arguments[0], params = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
    return function() {
      var args, event, renderContext;
      args = Array.prototype.slice.call(arguments);
      renderContext = args.pop();
      event = args.pop();
      args.push.apply(args, params);
      args.push(event);
      args.push(renderContext);
      return f.apply(this, args);
    };
  };

  Batman.Filters.logAndAssignToWindowVariable = function(value, variable) {
    console.log(value);
    window[variable] = value;
    return value;
  };

  Batman.Filters.any = function(objList, attr) {
    var obj, _i, _len;
    if (!(objList && objList.length)) {
      return false;
    }
    for (_i = 0, _len = objList.length; _i < _len; _i++) {
      obj = objList[_i];
      if (obj && obj.constructor.get && obj.get(attr)) {
        return true;
      }
    }
    return false;
  };

}).call(this);
